# coding: utf-8

"""
    Koverse Data Platform (KDP) API

    The KDP API is a REST API that can be used to create, access, and update data in KDP Workspaces. Please note that the Python client library follows Python's naming convention of snake casing for fields, even though they may appear in camel case in the API specification. <p><b>By default this api documentation targets the koverse production server at 'api.app.koverse.com' You can provide the hostname of your koverse instance to this documentation page via the 'host' query param.</p> <p><b>For example providing host - https://koverse-docs.saic.com/api?host=api.myHost.com, will update requests to target the provided host.</b></p> <p><b>Authentication request example with provided host - https://api.myHost.com/authentication</b></p>

    The version of the OpenAPI document: 4.166.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class Job(BaseModel):
    """
    Job
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="job ID")
    type: StrictStr = Field(description="job type")
    status: Optional[StrictStr] = Field(default=None, description="job status")
    config: Optional[Dict[str, Any]] = Field(default=None, description="job config")
    error: Optional[Dict[str, Any]] = Field(default=None, description="job error")
    stage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="job stage")
    total_stages: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="count of stages", alias="totalStages")
    dataset_id: StrictStr = Field(description="dataset ID", alias="datasetId")
    workspace_id: StrictStr = Field(description="workspace ID", alias="workspaceId")
    user_id: StrictStr = Field(description="user ID", alias="userId")
    __properties: ClassVar[List[str]] = ["id", "type", "status", "config", "error", "stage", "totalStages", "datasetId", "workspaceId", "userId"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['ingest', 'reindex', 'clear-dataset', 'delete-record', 'delete-document']):
            raise ValueError("must be one of enum values ('ingest', 'reindex', 'clear-dataset', 'delete-record', 'delete-document')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['queued', 'running', 'completed', 'canceled', 'failed']):
            raise ValueError("must be one of enum values ('queued', 'running', 'completed', 'canceled', 'failed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Job from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Job from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "status": obj.get("status"),
            "config": obj.get("config"),
            "error": obj.get("error"),
            "stage": obj.get("stage"),
            "totalStages": obj.get("totalStages"),
            "datasetId": obj.get("datasetId"),
            "workspaceId": obj.get("workspaceId"),
            "userId": obj.get("userId")
        })
        return _obj


